Forum.WEB/Controllers/HomeController.cs
using AutoMapper;
using Forum.BLL.Interfaces;
using Forum.BLL.Services;
using Forum.WEB.Models;
using Forum.WEB.ViewModel;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace Forum.WEB.Controllers
{
    /// <summary>
    ///     Controller that performs display of all categories and topics
    /// </summary>
    public class HomeController : Controller
    {
        private readonly IDiscussionCategoryService _discussionCategoryService;
        private readonly IMapper _mapper;

        /// <summary>
        ///     Method that creates the discussion controller (add discussion and view all discussions)
        /// </summary>
        /// <param name="mapper">
        ///     Mapper to create projections of one model in other model
        /// </param>
        /// <param name="discussionCategoryService">
        ///     Interface for working with categories in the database indirectly
        /// </param>
        public HomeController(IMapper mapper,
            IDiscussionCategoryService discussionCategoryService)
        {
            _mapper = mapper;
            _discussionCategoryService = discussionCategoryService;
        }


        /// <summary>
        ///     Method that renders page with categories and topics
        /// </summary>
        /// <returns>
        ///     Page with categories and topics
        /// </returns>
        public IActionResult Index()
        {
            IEnumerable<DiscussionCategoryViewModel> Category = 
                _mapper.Map<IEnumerable<DiscussionCategoryViewModel>>(_discussionCategoryService.GetAllAsync().Result);
            foreach (var item in Category)
            {
                item.Topics = _mapper.Map<List<DiscussionTopicViewModel>>(_discussionCategoryService.GetAllDiscussionTopicOfDiscussionCategoryAsync(item.Id).Result);
                item.CountAllDiscussion = _discussionCategoryService.CountAllDiscussionOfCategoryId(item.Id).Result;
            }

            StartViewModel startView = new StartViewModel { AllCategory = Category };

            return View(startView);
        }


        public IActionResult StartPage()
        {
            return View();
        }


        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Forum.WEB/Controllers/TopicController.cs
using AutoMapper;
using Forum.BLL.Interfaces;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using Forum.WEB.ViewModel;
using Forum.BLL.DTO;
using System.Collections.Generic;
using System;
using System.Linq;

namespace Forum.WEB.Controllers
{
    /// <summary>
    ///     Controller that performs display of all topics and their discussions
    /// </summary>
    public class TopicController : Controller
    {
        private readonly IDiscussionTopicService _discussionTopicService;
        private readonly IDiscussionService _discussionService;
        private readonly IMapper _mapper;

        /// <summary>
        ///     Method that creates the ropic controller (add topic, add discussion to topic)
        /// </summary>
        /// <param name="mapper">
        ///     Mapper to create projections of one model in other model
        /// </param>
        /// <param name="discussionService">
        ///     Interface for working with discussion in the database indirectly
        /// </param>
        /// <param name="discussionTopicService">
        ///     Interface for working with topics in the database indirectly
        /// </param>
        public TopicController(
            IMapper mapper,
            IDiscussionService discussionService,
            IDiscussionTopicService discussionTopicService)
        {
            _mapper = mapper;
            _discussionService = discussionService;
            _discussionTopicService = discussionTopicService;
        }


        /// <summary>
        ///     Method that renders page with discussion on the chosen topic
        /// </summary>
        /// <param name="topicId">
        ///     Id topic where do we want to see all discussion
        /// </param>
        /// <returns>
        ///     Page with discussion on the chosen topic
        /// </returns>
        [HttpGet]
        public IActionResult Index(string topicId)
        {
            DiscussionTopicViewModel discussionTopic =
                _mapper.Map<DiscussionTopicViewModel>(_discussionTopicService.GetAsync(Convert.ToInt32(topicId)).Result);

            discussionTopic.Discussions = 
                _mapper.Map<List<DiscussionViewModel>>(_discussionService.GetAllDiscussionOfDiscussionTopicAsync(Convert.ToInt32(topicId)).Result);

            AddDiscussionTopicViewModel addDiscussionTopicView = new AddDiscussionTopicViewModel
            {
                discussionTopicViewModel = discussionTopic
            };

            return View(addDiscussionTopicView);
        }


        /// <summary>
        ///     Method that renders page with add new topic in the chosen category
        /// </summary>
        /// <param name="categoryId">
        ///     Id categoty where do we want to add topic
        /// </param>
        /// <returns>
        ///     Page with add new category fields
        /// </returns>
        [HttpGet]
        public IActionResult CreatTopic(string categoryId)
        {
            return View(new DiscussionTopicViewModel() {IdCategory = Convert.ToInt32(categoryId) });
        }

        /// <summary>
        ///     Method that process creat topic for provided topic data
        /// </summary>
        /// <param name="TopicModel">
        ///     Topic data from form
        /// </param>
        /// <returns>
        ///     Main page with all topics
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> CreatTopic(DiscussionTopicViewModel TopicModel)
        {
            var checkTopic = await _discussionTopicService.GetAllAsync();
            if (checkTopic.Where(x => x.Topic.ToLower() == TopicModel.Topic.ToLower()).Count() > 0)
            {
                ModelState.AddModelError("", "Такая тема уже есть");
                return View(TopicModel);
            }

            DiscussionTopicDTO category = new DiscussionTopicDTO()
            {
                Topic = TopicModel.Topic,
                IdCategory = TopicModel.IdCategory
            };

            await _discussionTopicService.CreateAsync(category);

            return RedirectToAction("Index", "Category", new { categoryId = TopicModel.IdCategory.ToString()});
        }

        /// <summary>
        ///     Method that process dell topic for provided topic data
        /// </summary>
        /// <param name="topicId">
        ///     Id topic wich we wand delete
        /// </param>
        /// <param name="categoryId">
        ///     Id category to wich we retern after delete
        /// </param>
        /// <returns>
        ///     Main page with all topics
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> DeleteTopic(string topicId, string categoryId)
        {
            await _discussionTopicService.Delete(Convert.ToInt32(topicId));
            return RedirectToAction("Index", "Category", new { categoryId = categoryId });
        }


        /// <summary>
        ///     Method that renders page with edit topic fields
        /// </summary>
        /// <returns>
        ///     Page with edit topic fields
        /// </returns>
        [HttpGet]
        public IActionResult EditTopic(string topicId)  
        {
            var tmp = _discussionTopicService.GetAsync(Convert.ToInt32(topicId)).Result;
            return View(_mapper.Map<DiscussionTopicViewModel>(tmp));
        }


        /// <summary>
        ///     Method that process edit category for provided topic data
        /// </summary>
        /// <param name="TopicModel">
        ///     Topic data from form
        /// </param>
        /// <returns>
        ///     Main page with all topic with one category
        /// </returns>
        [HttpPost]
        public async Task<IActionResult> EditTopic(DiscussionTopicViewModel TopicModel)
        {
            var checkRole = await _discussionTopicService.GetAllAsync();
            if (checkRole.Where(x => x.Topic.ToLower() == TopicModel.Topic.ToLower()).Count() > 0)
            {
                ModelState.AddModelError("", "Такая тема уже есть");
                return View(TopicModel);
            }

            await _discussionTopicService.Update(_mapper.Map<DiscussionTopicDTO>(TopicModel));

            return RedirectToAction("Index", "Category", new { categoryId = TopicModel.IdCategory });
        }
    }
}

Forum.WEB/Views/Home/Index.cshtml
@model Forum.WEB.ViewModel.StartViewModel
@{
    ViewData["Title"] = "Home Page";
}

<h2>Список Категорий</h2>
<table class="table">
    <tr>
        <td>Имя и перечень тем в категории</td>
        <td>Количество обсуждений</td>
        @if (User.IsInRole("Root"))
        {
            <td>Редактирование/удаление категории</td>
        }
    </tr>
    @foreach (var category in Model.AllCategory)
    {
        <tr>
            <div>
                <td>
                    <form asp-action="Index" asp-controller="Category" method="get">
                            <input type="hidden" name="categoryId" value="@category.Id" />
                            <input type="submit" value="@category.CategotyName" class="btn button" />
                    </form>
                    @foreach(var item in category.Topics)
                    {
                        <ul>
                            <li>
                                <form  asp-action="Index" asp-controller="Topic" method="get">
                                    <input type="hidden" name="topicId" value="@item.Id" />
                                    <input type="submit" value="@item.Topic" class="btn button" />
                                </form>
                            </li>
                        </ul>
                    }
                </td>
                <td>
                    @category.CountAllDiscussion
                </td>

                @if (User.IsInRole("Root"))
                {
                    <td>
                        <form asp-action="EditCategory" asp-controller="Category" method="get" >
                            <input type="hidden" name="categoryId" value="@category.Id" />
                            <button type="submit" class="btn btn-sm btn-success">
                                Редактировать
                            </button>
                        </form>


                        <form asp-action="DeleteCategory" asp-controller="Category" method="post" >
                            <input type="hidden" name="categoryId" value="@category.Id" />
                            <button type="submit" class="btn btn-sm btn-danger">
                                Удалить
                            </button>
                        </form>
                    </td>
                } 
            </div>
        </tr>
    }
</table>

<footer>
@if (User.Identity.IsAuthenticated && User.IsInRole("Root"))
{
    <a asp-controller="Category" asp-action="CreatCategory">Добавить категорию</a>
}
</footer>

Forum.WEB/Views/Home/StartPage.cshtml
<h1>Стартовавя страница</h1>